using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace MoveableControlDemo
{
    public partial class MoveableBaseControl : UserControl
    {
        private bool _isMoving = false;
        private int _deltaX = 0;
        private int _deltaY = 0;

        public MoveableBaseControl()
        {
            InitializeComponent();
        }

        private void MoveableBaseControl_MouseDown(object sender, MouseEventArgs e)
        {
            _isMoving = true;
            _deltaX = e.X;
            _deltaY = e.Y;
        }

        private void MoveableBaseControl_MouseUp(object sender, MouseEventArgs e)
        {
            _isMoving = false;
        }

        private void MoveableBaseControl_MouseMove(object sender, MouseEventArgs e)
        {
            if (_isMoving && e.Button == MouseButtons.Left)
            {
                this.Location = new Point(this.Location.X + (e.X - _deltaX), this.Location.Y + (e.Y - _deltaY));
            }
        }

        

        private void MoveableBaseControl_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.W:

                    this.Location = new Point(this.Location.X, this.Location.Y - 5);
                    break;

                case Keys.S:
                    this.Location = new Point(this.Location.X, this.Location.Y + 5);
                    break;

                case Keys.A:
                    this.Location = new Point(this.Location.X - 5, this.Location.Y);
                    break;

                case Keys.D:
                    this.Location = new Point(this.Location.X + 5, this.Location.Y);
                    break;

            }
        }
    }
}
